///////////////////////////////////////////////////////////////////////////////
// TEDSoft GmbH Bonn 2002 -- tool source code                                //
// Alle Rechte vorbehalten                                                   //
// All rights reserved -- unless granted by written agreement.               //
// To remove this notice is not permitted.                                   //
//                                                                           //
//  www  : www.tedsoft.de                                                    //
//  mail : info@tedsoft.de                                                   //
///////////////////////////////////////////////////////////////////////////////

{$A+,B-,G-,H+,I+,J-,M-,P-,T+,V+,X+,Z1}  // Standard-Settings neuer Code

unit uTEDVersionLabel;

interface

uses
  SysUtils, Classes, Controls, StdCtrls, uTEDVersionInfo, Forms;

type
  TVersionInfoString = String;

  TTEDVersionLabel = class(TLabel)
  private
    FVersionInfo : TTEDVersionInfo;
    FInfoType    : TVersionInfoString;
    FVersionText : String;
    function GetInfoType: TVersionInfoString;
    procedure SetInfoType (const Value: TVersionInfoString);
  protected
    function GetLabelText: String; override;
    property Caption;
  public
    constructor Create (AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property VersionInfo: TVersionInfoString read GetInfoType write SetInfoType;
  end;

implementation

var
  TEDVersionInfo: TTEDVersionInfo;

{ TTEDVersionTabel }

constructor TTEDVersionLabel.Create(AOwner: TComponent);
begin
  inherited Create (AOwner);
  ShowAccelChar := False;
  FVersionInfo := TEDVersionInfo;
  VersionInfo := VersionInfoStrings[TVersionInfoStrings (0)];
end;

destructor TTEDVersionLabel.Destroy;
begin
  inherited Destroy;
end;

function TTEDVersionLabel.GetInfoType: TVersionInfoString;
begin
  Result := FInfoType;
end;

function TTEDVersionLabel.GetLabelText: String;
begin
  Result := inherited GetLabelText + FVersionText;
end;

procedure TTEDVersionLabel.SetInfoType (const Value: TVersionInfoString);
begin
  FInfoType := Value;
  if   csDesigning in ComponentState
  then FVersionText := 'VersionInfo:' + FInfoType
  else if   FVersionInfo.Active
       then FVersionText := FVersionInfo.QueryValue (FInfoType)
       else FVersionText := '';
  Perform(CM_TEXTCHANGED, 0, 0);
end;

initialization
  TEDVersionInfo := TTEDVersionInfo.Create;
  TEDVersionInfo.FileName := Application.ExeName;
  try
    TEDVersionInfo.OpenVersion;
  except
    on ETEDVersionInfo do ; // exception from TTEDVersionInfo, do nothing here
  else
    raise; // something strange occured
  end;
finalization
  TEDVersionInfo.Free;
end.
